<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Grid.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Grid.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


define(['underscore', 'jquery', 'uweaver/lang', 'uweaver/formatter', 'uweaver/string',
    'uweaver/widget/Widget', 'uweaver/data/Collection', 'uweaver/data/Model', 'uweaver/i18n',
    'uweaver/widget/Textbox', 'uweaver/widget/Numberbox', 'uweaver/widget/Datebox',
    'text!./tpl/Grid.html'], function (_, $, lang, formatter, string, Widget, Collection, Model, i18n,
                                       Textbox, Numberbox, Datebox, tpl) {

    var declare = lang.declare;
    var Base = Widget;

    /**
     * This class represents a table.
     *
     * ##### Usage
     *     // Declare a new type of collection, Products, with the following designs:
     *     // * the resource - 'products'
     *     var declare = uweaver.lang.declare;
     *     var Products = declare(Collection, {
     *         resource: 'products'
     *     });
     *
     *     var items = new Products();
     *
     *     var renderer = function(item) {
     *          return '&lt;i class="fa fa-trash uw-hover uw-clickable" style="font-size:24px;">&lt;/i>';
     *     };
     *
     *     var handler = function(item, dataIndex) {
     *          expect(item.cid).to.not.be.empty;
     *     };
     *
     *     var grid = new Grid({
     *         data: items,
     *         columns: [
     *             {text: "", handler: Grid.HANDLER.SELECTOR},
     *             {text: "", renderer: renderer, handler: handler},
     *             {text: "ID", dataIndex: "id", style: {width: '100px'}},
     *             {text: "Name", dataIndex: "name", style: {width: '150px'}},
     *             {text: "Price", dataIndex: "price", editable: true, style: {width: '80px'}},
     *             {text: "Note", dataIndex: "note"}],
     *        mode: Grid.MODE.SINGLE,
     *        el: $('#grid')
     *     });
     *     grid.render();
     *
     *     var pagination = new Pagination({
     *         data: items,
     *         el: this.$('#pagination')
     *     });
     *     pagination.render();
     *
     *     // fetch the data(models).
     *     // the grid &amp; pagination will re-render after fetch completely.
     *     items.fetch();
     *
     * ##### Template
     *     &lt;!-- the following dom are required.
     *     + table - the table.
     *     -->
     *     &lt;table class="table table-striped">&lt;/table>
     *
     * ##### Events:
     * + 'select' - [select()]{@link Grid#select}, [toggle()]{@link Grid#toggle}
     * + 'deselect' - [deselect()]{@link Grid#deselect}, [toggle()]{@link Grid#toggle}
     * + 'transition' - [data()]{@link Grid#data}
     *
     * @constructor Grid
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {String} [config.tpl] - A html string to layout &amp; construct the DOM element.
     * @param {Collection} [config.data=new Collection()] - A collection to specify the models to display.
     * @param {Grid.MODE} [config.mode=Grid.MODE.NONE] - A value to specify the selection model. Grid.MODE.SINGLE for single selection.
     * Grid.MODE.MULTI for multiple selection or Grid.MODE.NONE to disable selection.
     * @param {boolean} [allowNullSelection=true] - A value to specify if the user can deselect all the selections.
     * @param {int} [config.maxRowsToShow] - A value to specify height of the grid based on the number of rows to show.
     * @param {Object[]} [config.columns=[]] - An array of column configuration to define the columns. For examples:
     * [{text: "ID", dataIndex: "id"},{text: "Name", dataIndex: "name"}].
     * #####Column Configuration:
     * + text:String - the caption. required.
     * + dataIndex:String - the property of the model. required.
     * + type:String - the type of the property. optional.
     * + subtype:String - the subtype of the property. required.
     * + step:number - Specifies the legal number intervals for the number field. optional.
     * + style:Object - the css of the column. optional.
     * + editable:Boolean - A boolean value to specify if the column is editable. default: false.
     * + editor:Inputbox - Specifies an inputbox for the user to edit the column if the column is editable.
     * + pattern:String - the presentation format of the column. optional.
     * + renderer:Function(item) - a function to render the cells of the column. The current model is passed as the
     * item parameter and the function should return the html to display inside the cell. optional.
     * + handler:Function(item, dataIndex) - a function to be call when the cells of the column are clicked.
     * The current model &amp; dataIndex are passed as the item parameter. optional.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {
            data: new Collection(),
            mode: Grid.MODE.NONE,
            allowNullSelection: true,
            columns: []
        };
        var cfg = this._cfg;

        _.defaults(cfg, defaults);

        this._columns = cfg.columns;

        this.mode(cfg.mode);

        this.data(cfg.data, {render: false});

        cfg.tpl || (cfg.tpl = tpl);

        $(document).on('click', _.bind(onDocumentClick, this));

        (this.$('table').length===0 &amp;&amp; this.el.tagName!=='TABLE') &amp;&amp; this.$el.append('&lt;table>&lt;/table>');

        this._$table = (this.$('table').length===0) ? this.$el : this.$('table');
        this._$heading = this._$table.clone();
        this._$heading.attr('role', 'heading');
        this._$heading.css({
            'margin-bottom' : '0px'
        });
        this._$table.css({
            'margin-top' : '0px'
        });

        (this._$table.find('thead').size()===0) &amp;&amp; this._$table.append('&lt;thead>&lt;/thead>');
        (this._$table.find('tbody').size()===0) &amp;&amp; this._$table.append('&lt;tbody>&lt;/tbody>');
        (this._$heading.find('thead').size()===0) &amp;&amp; this._$heading.append('&lt;thead>&lt;/thead>');

        this._freezeRenderer = _.throttle(freezeRenderer, 100);

        $(window).on('resize', _.bind(this._freezeRenderer, this));
    }

    /**
     * @override
     */
    function render(options) {
        Base.prototype.render.apply(this, arguments);

        var defaults = {
            hidden: false
        };

        options || (options = {});
        _.defaults(options, defaults);

        this._editableCell = undefined;
        if(this._editor) {
            this._editor.detach();
            this.stopListening(this._editor);
            this._editor = undefined;
        }

        var $headingThead = this._$heading.find('thead');
        var $tableThead = this._$table.find('thead');
        var $tbody = this._$table.find('tbody');

        $headingThead.empty();
        $tableThead.empty();
        $tbody.empty();

        var data = this._data;
        var row = "&lt;tr>";
        var maxRowsToShow = this.cfg().maxRowsToShow || data.size();
        _.each(this._columns, function(element, index){
            var text = element.text;
            var style = element.style || {};
            var indicator = "";

            if(element.editable) {
                indicator = indicator + "&lt;i class='fa fa-pencil' style='margin-left:5px;'>&lt;/i>";
            } else if(element.handler===Grid.HANDLER.SELECTOR &amp;&amp; this.cfg().mode!==Grid.MODE.NONE) {
                if(this.cfg().mode===Grid.MODE.MULTI) {
                    indicator = indicator + "&lt;input type='checkbox'>";
                }
                style = {width: '40px', 'text-align': 'center'};
                this._selectorIndex = index;
            }

            if((data.length>0) &amp;&amp; _.isNumber(data.at(0).get(element.dataIndex))) {
                style['text-align'] = 'right';
                style['padding-right'] = '12px';
            }
            row = row + "&lt;th style= '" + toCssText(style) + "'>&lt;span>" + text + indicator + "&lt;/span>&lt;/th>";
        }, this);
        row = row + "&lt;/tr>";
        $headingThead.append(row);
        $tableThead.append(row);

        data.each(function(item, index){
            var row = "&lt;tr>";
            _.each(this._columns, function(element, index){
                var value;
                var renderer = element.renderer;
                var style = element.style || {};

                if(_.isFunction(renderer)) {
                    value = renderer(item);
                    if(element.type==='number') {
                        _.defaults(style, {
                            'text-align': 'right',
                            'padding-right': '12px'
                        });
                    }
                } else if(element.handler===Grid.HANDLER.SELECTOR) {
                    value = "&lt;input type='checkbox' value='" + item.cid + "'>";
                    style = {width: '40px', 'text-align': 'center'};
                } else {
                    var dataIndex = element.dataIndex;
                    value = formatter.format(item.get(dataIndex), {
                        subtype: element.subtype,
                        pattern: element.pattern
                    });
                    if(element.type==='number'||_.isNumber(item.get(dataIndex))) {
                        _.defaults(style, {
                            'text-align': 'right',
                            'padding-right': '12px'
                        });
                    }
                }


                row = row + "&lt;td data-uw-index='" + index + "' style= '" + toCssText(style) + "'>"
                    + ((value==undefined||value==null) ? "" : value) + "&lt;/td>";
            }, this);
            row = row + "&lt;/tr>";
            var $row = $(row);
            (index &lt; maxRowsToShow) || $row.hide();
            $row.data('cid', item.cid);
            $tbody.append($row);
        }, this);

        if(this._selectorIndex!==undefined) {
            var selector = this.$('thead>tr>th').get(this._selectorIndex);
            $(selector).children().on('click', _.bind(function(event){
                var $selector = $(event.currentTarget);

                $selector.prop('checked') ? this.selectAll() : this.deselectAll();

            }, this))
        }
        if(data.size()===0) {
            var nodata = "&lt;tr>&lt;td colspan='${columns}' style='text-align:center'>No Data&lt;/td>&lt;/tr>";
            $tbody.append(string.substitute(nodata, {columns: this._columns.length}));
        } else {
            this.$('tbody>tr').on('click', _.bind(onRowClick, this));
            this.$('tbody>tr>td').on('click', _.bind(onCellClick, this));
            this.renderSelection();
        }

        this._$table.css({
            'margin-top': '0px'
        });

        this._$heading.hide();

        options.hidden || this.show();

        postRender.call(this);

        return this;
    }

    function postRender() {
        if(!this.isVisible()) {
            setTimeout(_.bind(postRender, this), 100);
            return;
        }

        if(this._$wrapper===undefined) {
            this._$wrapper = $("&lt;div role='wrapper'>&lt;div role='window' style='overflow-y: auto'>&lt;/div>&lt;/div>");
            this._$table.wrap(this._$wrapper);
            this._$window = this._$table.parent();
            this._$window.before(this._$heading);
            this._$window.css({
                'margin-bottom': this._$table.css('margin-bottom')
            });
            this._$table.css({
                'margin-bottom': '0px'
            });
        }

        this._$window.height(this._$table.outerHeight());

        this._isRendered = true;

        this.trigger('render', {
            data: {},
            context: this,
            source: this
        });

        this._freezeRenderer.call(this);
    }

    function freezeRenderer() {
        if(!this.isRendered()) return;

        var maxRowsToShow = this.cfg().maxRowsToShow;
        var $rows = this._$table.find('tbody > tr');
        var size = $rows.length;
        var $tableThs = this._$table.find('thead > tr > th');
        var $theadingThs = this._$heading.find('thead > tr > th');


        if(size===0||!maxRowsToShow) return;

        this._$heading.get(0).className = this._$table.get(0).className;

        $rows.show();
        $theadingThs.each(function(index, th) {
            if(index===$theadingThs.length-1) {
                $(th).css('width', '');
                return;
            }
            var width = $($tableThs.get(index)).outerWidth();
            $(th).outerWidth(width);
        });

        this._$heading.show();

        this._$table.css({
            'margin-top': (this._$heading.outerHeight() * -1) + 'px'
        });

        for(var i=maxRowsToShow; i&lt;size; i++) {
            $($rows.get(i)).hide();
        }
        this._$window.height(this._$table.outerHeight() - this._$heading.outerHeight());
        $rows.show();

    }

    function toCssText(style) {
        var cssText = "";
        _.each(style, function(value, key) {
            cssText = cssText + key + ":" + value + ";";
        });
        return cssText;
    }

    function onRowClick(event) {
        if(this._editor &amp;&amp; event.target===this._editor.el) return;

        var $row = $(event.currentTarget);
        var cid = $row.data('cid');
        this.toggle(cid);
    }

    function onCellClick(event) {
        if(this._editor &amp;&amp; event.target===this._editor.el) return;

        var $cell = $(event.currentTarget);
        var index = $cell.attr('data-uw-index');
        var column = this._columns[index];
        var $row = $cell.parent();
        var cid = $row.data('cid');
        var item = this.data().get(cid);
        var dataIndex = column.dataIndex;

        if(column.handler) {
            if(column.handler!==Grid.HANDLER.SELECTOR) {
                column.handler(item, dataIndex);
            }
        }

        if(!column.editable) return;

        if(_.first($cell)=== _.first(this._editableCell)) {
            return;
        }

        renderCell.call(this, this._editableCell);
        makeCellEditable.call(this, $cell);
        this._freezeRenderer.call(this);

    }

    function onDocumentClick(event) {
        if(this._editor &amp;&amp; event.target===this._editor.el) return;

        if(!this.isVisible()) return;

        var $cell = $(event.target).closest('td');

        if(_.first($cell)=== _.first(this._editableCell)) {
            return;
        }

        renderCell.call(this, this._editableCell);

        this._editableCell = undefined;

        this._freezeRenderer.call(this);
    }


    function makeCellEditable(cell) {
        var $cell = cell;
        if($cell.data('mode')==='edit') return;

        var index = $cell.attr('data-uw-index');
        var column = this._columns[index];
        var dataIndex = column.dataIndex;
        var $row = $cell.parent();
        var cid = $row.data('cid');
        var value = this.data().get(cid).get(dataIndex);
        var subtype = column.subtype;

        // preserve cell's style
        $cell.data('padding-top', $cell.css('padding-top'));
        $cell.data('padding-bottom', $cell.css('padding-bottom'));

        $cell.css('padding-top', '4px');
        $cell.css('padding-bottom', '4px');

        var editor = column.editor || buildEditor.call(this, value, column);
        editor.clear();

        editor.attr('cid', cid);
        editor.attr('dataIndex', dataIndex);
        editor.css('width', "100%");editor.outerHeight($cell.height());
        editor.css('padding', '0px 6px');
        editor.value(value);
        this.listenTo(editor, 'change', _.bind(onEditorChange, this));

        $cell.empty();
        editor.attach($cell);

        this._editableCell = $cell;
        this._editor = editor;
    }

    function buildEditor(value, column) {
        var editor;
        var type = column.type;
        var subtype = column.subtype;

        if(!type) {
            if(subtype==='currency') {
                type = 'number';
            } else if(subtype==='datetime'||subtype==='date'||subtype==='time'||subtype==='month') {
                type = 'date';
            }
        }

        if(_.isNumber(value)||type==='number') {
            var step;
            if(column.step) {
                step = column.step;
            } else {
                var p = precision(value);
                step = p > 0 ? 1/(p*10) : 0;
            }

            editor = new Numberbox({
                type: 'number',
                step: step
            });
        } else if(_.isDate(value)||type==='date') {
            var type;
            if(subtype=='date') {
                type = 'date';
            } else if(subtype=='datetime') {
                type = 'datetime-local';
            } else if(subtype=='time') {
                type = 'time';
            } else {
                type = 'datetime-local';
            }
            editor = new Datebox({
                type: type
            });
        } else {
            editor = new Textbox();
        }

        column.editor = editor;

        return editor;
    }

    function precision(n) {
        if (!isFinite(n)) return 0;
        var e = 1, p = 0;
        while (Math.round(n * e) / e !== n) { e *= 10; p++; }
        return p;
    }

    function onEditorChange(event) {
        var editor = event.context;
        var cid = editor.attr('cid');
        var dataIndex = editor.attr('dataIndex');

        this.data().get(cid).set(dataIndex, editor.value(), {context: this});
    }

    function renderCell(cell) {
        if(!cell) return;

        if(this._editor) {
            this._editor.detach();
            this.stopListening(this._editor);
            this._editor = undefined;
        }

        var $cell = cell;
        var index = $cell.attr('data-uw-index');
        var column = this._columns[index];
        var dataIndex = column.dataIndex;
        var pattern = column.pattern;
        var type = column.type;
        var subtype = column.subtype;
        var renderer = column.renderer;
        var $row = $cell.parent();
        var cid = $row.data('cid');
        var item = this.data().get(cid);
        var value = item.get(dataIndex);
        var html = _.isFunction(renderer) ? renderer(item) : formatter.format(value, {
            subtype: subtype,
            pattern: pattern
        });

        //restore cell's style
        $cell.css('padding-top', $cell.data('padding-top'));
        $cell.css('padding-bottom', $cell.data('padding-bottom'));
        $cell.data('padding-top', undefined);
        $cell.data('padding-bottom', undefined);

        $cell.html(html);
    }

    /**
     * Toggle a model's selection status.
     *
     * ##### Events:
     * + 'select' - triggered after a model is selected. event.data => the selected model.
     * + 'deselect' - triggered after a model is deselected. event.data => the deselected model.
     *
     * @memberof Grid#
     * @param {Object} item - The model, model.id or model.cid.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @returns {Grid} this
     */
    function toggle(item, options) {
        if(!item) return this;
        var mode = this._mode;
        var allowNullSelection = this.cfg().allowNullSelection;

        if(mode===Grid.MODE.NONE) return this;

        var model = (item instanceof Model) ? item : this.data().get(item);

        var cid = model.cid;

        options || (options = {});

        if(_.contains(this._selection, cid)) {
            allowNullSelection &amp;&amp; this.deselect(item, options);
        } else {
            this.select(item, options);
        }

        return this;
    }

    /**
     * Deselect a model.
     *
     * ##### Events:
     * + 'deselect' - triggered after a model is selected. event.data => the deselected model.
     *
     * @memberof Grid#
     * @param {Object} item - The model, model.id or model.cid
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @returns {Grid} this
     */
    function deselect(item, options) {
        if(!item) return this;

        var mode = this._mode;

        if(mode===Grid.MODE.NONE) return this;

        options || (options = {});

        var model = (item instanceof Model) ? item : this.data().get(item);

        if(!model) return this;

        var cid = model.cid;

        if(!_.contains(this._selection, cid)) return this;

        this._selection = _.without(this._selection, cid);

        this.renderSelection();

        var event = {
            context: this,
            source: this,
            data: model
        };

        (options.silent) || this.trigger('deselect', event);

    }

    /**
     * Select a model.
     *
     * ##### Events:
     * + 'select' - triggered after a model is selected. event.data => the selected model.
     *
     * @memberof Grid#
     * @param {Object} item - The model, model.id or model.cid
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @returns {Grid} this
     *
     * @todo select multiple items.
     */
    function select(item, options) {
        if(!item) return this;

        var mode = this._mode;

        if(mode===Grid.MODE.NONE) return this;

        options || (options = {});

        var model = (item instanceof Model) ? item : this.data().get(item);

        if(!model) return this;

        var cid = model.cid;

        if(mode===Grid.MODE.SINGLE) {
            this.deselect(_.first(this._selection));
        }

        this._selection.push(cid);

        this.renderSelection();

        var event = {
            context: this,
            source: this,
            data: model
        };

        (options.silent) || this.trigger('select', event);
    }

    /**
     * @todo trigger event.
     */
    function selectAll() {
        var items = this.data();

        this._selection = [];
        
        items.each(function(item) {
            this._selection.push(item.cid);
        }, this);

        this.renderSelection();
    }

    /**
     * @todo trigger event.
     */
    function deselectAll() {

        this._selection = [];

        this.renderSelection();
    }

    /**
     * Reset the grid to deselect all selection.
     *
     * @memberof Grid#
     * @returns {Grid} this
     */
    function reset() {
        this._selection = [];
        this.renderSelection();
        return this;
    }

    /**
     * Get the selected model.
     *
     * @memberof Grid#
     * @returns {Model[]} the array of selected model
     */
    function selection() {
        var items = [];
        var data = this._data;

        _.each(this._selection, function(id) {
            items.push(data.get(id));
        });

        return items;
    }

    function renderSelection() {
        _.each(this.$('tbody>tr'), function(element) {
            var $element = $(element);
            var cid = $element.data('cid');
            var selector = (this._selectorIndex===undefined) ? undefined : $(element).find('>td')[this._selectorIndex];
            var checked = false;
            if(_.contains(this._selection, cid)) {
                $element.addClass('uw-mark');
                checked = true;
            } else {
                $element.removeClass('uw-mark');
                checked = false;
            }

            if(selector) {
                $(selector).children().prop('checked', checked);
            }
        }, this);
    }

    /**
     * Get or set the data.
     *
     * ##### Events:
     * + 'transition' - triggered after a new collection is bound. event.data => the collection.
     *
     * @memberof Grid#
     * @param {Collection} items - the data.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @param {Boolean} [options.render=true] - A false value will prevent the grid from being rendered.
     * @returns {Collection|Grid}
     */
    function data(items, options) {
        if(!items) return this._data;

        options || (options = {});

        var defaults = {
            render: true
        };

        _.defaults(options, defaults);

        if(this._data) this.stopListening(this._data);

        this._data = items;

        this.listenTo(this._data, "update reset sync", _.bind(onItemsUpdate, this));
        this.listenTo(this._data, "change", _.bind(onItemChange, this));

        this._selection = [];

        options.render &amp;&amp; this.render();

        var event = {
            context: this,
            source: this,
            data: items
        };

        (options.silent) || this.trigger('transition', event);

        return this;
    }


    /**
     * Get or set the selection model.
     *
     * @memberof Grid#
     * @param {Grid.MODE} [value] - An value to specify the selection model.
     * ##### Options:
     * + Grid.MODE.SINGLE - set the grid to single selection.
     * + Grid.MODE.MULTI - set the grid to multiple selection.
     * + Grid.MODE.NONE - set the grid to disable selection.
     * @returns {Grid.MODE}
     */
    function mode(value) {
        if(!value) return this._mode;

        this._mode = value;
        if(this._mode===Grid.MODE.NONE) {
            this.removeClass('uw-selectable');
        } else {
            this.addClass('uw-selectable');
        }
    }

    function onItemsUpdate(event) {
        this._selection = [];
        this.render();
    }

    function onItemChange(item, options) {
        if(this===options.context) {
            return;
        }

        this._selection = [];
        this.render();
    }


    var props = {
        tagName: 'table',
        className: 'table table-striped',
        _data: undefined,
        _columns: undefined,
        _mode: undefined,
        _selection: undefined,
        _editableCell: undefined,
        _selectorIndex: undefined,
        _$table: undefined,
        _$wrapper: undefined,
        _$scroller: undefined,
        _editor: undefined
    };

    var Grid = declare(Base, {
        initialize: initialize,
        render: render,
        select: select,
        selectAll: selectAll,
        deselect: deselect,
        deselectAll: deselectAll,
        toggle: toggle,
        reset: reset,
        data: data,
        mode: mode,
        selection: selection,
        renderSelection: renderSelection
    }, props);

    // Enumeration of the selection model
    Grid.MODE = {
        SINGLE: 'SINGLE',
        MULTI: 'MULTI',
        NONE: 'NONE'
    };

    Grid.HANDLER = {
        SELECTOR: 'SELECTOR'
    };

    return Grid;
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
